import { SelectWhere } from '../@types/commonType';
import { pushPayload } from '../helpers';


export const generateSQLSelect = (nameTable: string, {where, sql}:SelectWhere): {arrValuesPayload: any[], newSQLSelect: string} => {

  let arrTotalValuesPayload:any[] = [];
  let defaultSqlStr = ``;

  if(sql){
    defaultSqlStr += sql;
  }else if(where){
    defaultSqlStr += `SELECT * FROM ${nameTable} WHERE`;

    for(let key in where){
      defaultSqlStr += (` ${key} = ?,`);
      pushPayload(where[key], arrTotalValuesPayload);
    }
    defaultSqlStr = defaultSqlStr.replace(/,$/ig, ``);

  }else{
    console.dir('Не переданы из аргументов where | stringWhere');
  }

  return {
    arrValuesPayload: arrTotalValuesPayload,
    newSQLSelect: defaultSqlStr
  };
}